clc; clear;

%% import text file & save important distances in an int array
fileID = fopen('testRoute1.txt'); % open text file
inputTxt = textscan(fileID,'%c'); % read each line character by character, spaces are not read
fclose(fileID);
%celldisp(inputTxt);

inputTxtChar = inputTxt{1};
len = length(inputTxtChar);
distance = ''; % initialize a string that will hold all of the distance information
distanceVal = ''; % initialize values that will be added to distance string

for i=1:len
    if(isstrprop(inputTxtChar(i),'digit')) % checks if the char is a numeric digit (i.e. number)
        %disp(inputTxtChar(i)); disp(' is a number!');
        if(i~=1 && strcmp(inputTxtChar(i-1),'!')) % if previous input is !, do not add number, e.g. !4m13!4m, in url
            distanceVal = '';
        else
            distanceVal = strcat(distanceVal,inputTxtChar(i)); % concatenate (i.e. link) distanceVal with the number
        end
        
    elseif(strcmp(inputTxtChar(i),'.') && isempty(distanceVal)==false && isstrprop(distanceVal(end),'digit')) % if char is a period and last value in distanceVal is a number
        distanceVal = strcat(distanceVal,inputTxtChar(i)); 
        
    elseif(strcmp(inputTxtChar(i),'(')) % easier to remove distances in parantheses later
        distanceVal = strcat(distanceVal,inputTxtChar(i)); 
        
    elseif(strcmp(inputTxtChar(i),')')) % easier to remove distances in parantheses later
        distanceVal = strcat(distanceVal,inputTxtChar(i));
        if(isempty(distance))
           distance = distanceVal; % needed to make sure ':' does not appear at beginning of distance 
        end
        distance = strcat(distance,':',distanceVal); % concatenate distanceVal to distance
        distanceVal = ''; % reset distanceVal
        
    elseif(strcmp(inputTxtChar(i),'k'))
        distanceVal = strcat(distanceVal,inputTxtChar(i)); 
        
    elseif(strcmp(inputTxtChar(i),'m'))
        if(length(distanceVal)==0) % only m will be in distanceVal
            distanceVal = ''; % reset distanceVal
            
        elseif(i~=len && strcmp(inputTxtChar(i+1),')')) % if next char is ) -> reset distanceVal next iteration
            distanceVal = strcat(distanceVal,inputTxtChar(i));
            %distance = strcat(distance,':',distanceVal);
        
        elseif(i~=len && strcmp(inputTxtChar(i+1),'i')) % if next char is equal to i
            distanceVal = ''; % reset distanceVal, makes sure e.g. 9 min is not added
            
        else % add distanceVal to distance string
            distanceVal = strcat(distanceVal,inputTxtChar(i));
            %disp('What is distanceVal: '); disp(distanceVal);      
            if(isempty(distance))
                distance = distanceVal;
            else
                distance = strcat(distance,':',distanceVal);
            end
        end 
    else % input is not a digit
        distanceVal = ''; % clear distanceVal
    end
end

disp('distance: ');
disp(distance);
%% make an array of the important distances

distanceCellArray = strsplit(distance,':'); % split distance string into separate distance periods

disp('distanceCellArray: ');
disp(distanceCellArray);

distArray = zeros(length(distanceCellArray),1); % initialize final distance array, int values, in [m]
cntr = 1;

for k=1:length(distanceCellArray)
   currDistance = distanceCellArray{k};
   if(strcmp(currDistance(1),'(')) % if first char is '(' -> ignore
       % do nothing
   elseif(strcmp(currDistance(end-1),'k')) % contains [km] -> 
       distArray(cntr) = 1000*str2num(currDistance(1:end-2)); % take away km, change from [km] -> [m]
       cntr=cntr+1;
   elseif(strcmp(currDistance(end),'m')) % contains [m]
       distArray(cntr) = str2num(currDistance(1:end-1));
       cntr=cntr+1;
   end 
end

distArray = distArray(2:cntr-1); % first array val is total distance driven
disp('distArray: ');
disp(distArray);

%% find the height at equally spaced sample points in Google Maps

% find height positions by looking at bicycle path data in google
% maps
promptNumHeightPoints = 'How many equally spaced points do you want to use in the height profile? ';
numHeightPoints = input(promptNumHeightPoints); % numeric value
heightGoogleMaps = zeros(numHeightPoints,1); % initialize height matrix, first element is initial height, last element is final height
for i=1:numHeightPoints
    if(i==1)
        initialPrompt = 'Input the first height point in meters as an integer: ';
        heightGoogleMaps(i) = input(initialPrompt); % numeric value
    elseif(i==numHeightPoints) % final height point
        finalPrompt = 'Input the final height point in meters as an integer: ';
        heightGoogleMaps(i) = input(finalPrompt); % numeric value
    else
        nextPrompt = 'Input the next height point in meters as an integer: ';
        heightGoogleMaps(i) = input(nextPrompt); % numeric value
    end
end

%% find distance of the height sample points from Google Maps

totalDist = sum(distArray);
heightPointsDistCntr = 0; % counter to measure distance of the height sample points from Google Maps
distAtHeightGoogleMaps = zeros(numHeightPoints,1); % initialize, distance travelled at each height point
for i=1:numHeightPoints
    distAtHeightGoogleMaps(i) = heightPointsDistCntr;
    heightPointsDistCntr = heightPointsDistCntr + totalDist/(numHeightPoints-1);
end

%% find height of the known Google Maps path lengths, find height of distArray values, interpolate
distCntr = 0;
heightArray = zeros(length(distArray),1); % height of distArray values, find height for the distances given in Google Maps

for i=1:length(distArray)
    if(i==1) % first value
        heightArray(i) = heightGoogleMaps(1); 
    elseif(i==length(distArray)) % last value
        heightArray(i) = heightGoogleMaps(end); 
    else
        distCntr=distCntr+distArray(i-1);
        x = distAtHeightGoogleMaps; % sample points
        v = heightGoogleMaps; % v(x), height at sample points
        xq = distCntr; % distance value that you want to interpolate the height for
        heightArray(i) = interp1(x,v,xq); % linear interpolation 
    end
end

%% make a speed profile from the distance profiles, old version

% % Nissan Leaf accelerates 0-100 km/h in 10 s -> desAccel = 2.8 m/s, assume
% % a normal desAccel of 1 m/s
% for k=1:length(distArray)
%     if(k<length(distArray))
%         rise = heightArray(k+1)-heightArray(k);
%         run = distArray(k);
%         if(rise<=0)
%            desAccel = 1; % [m/s^2]
%         else % rise>0
%             if(run<=rise)
%                 desAccel = run/rise; % [m/s^2]
%             else
%                 desAccel = rise/run; % [m/s^2]
%             end
%             desAccel = max(1,desAccel); % makes sure that the desAccel is not too small
%         end
%     else 
%        desAccel = 1; % [m/s^2], assume last point is flat
%     end
%     %disp('desAccel: '); disp(desAccel);
%     
%     t = 50/(3.6*desAccel);
%     if(distArray(k)<(t*50/3.6)) % distance less than area of triangle with height 50 km/h
%         disp('Make a triangle!');
%         t = sqrt(distArray(k)/desAccel);
%         v = desAccel*t;
%         timeArrayLength = ceil(2*t)+1; % rounds up to nearest time
%         timeArray = (0:timeArrayLength-1)';
%         velArray = zeros(timeArrayLength,1);
%         for i=0:timeArrayLength-1
%             if(i<=t)
%                 velArray(i+1) = interp1([0;t],[0;v],i); % (x,v(x),x_interp)
%             else % i>t
%                 velArray(i+1) = interp1([t;ceil(2*t)],[v;0],i); % (x,v(x),x_interp)
%             end
%         end
%     else % distance > area of triangle with height 50 km/h, make a trapezoid
%         areaRect = distArray(k)-200;
%         tRect = areaRect/(50/3.6);
%         
%         areaTriang = distArray(k)-(50/3.6*tRect);
%         v = 50/3.6;
%         tTriang = areaTriang/v;
%         timeArrayLength = ceil(2*tTriang)+1+ceil(tRect); % rounds up to nearest time
%         timeArray = (0:timeArrayLength-1)';
%         velArray = zeros(timeArrayLength,1);
%         for i=0:timeArrayLength-1
%             if(i<=tTriang)
%                 velArray(i+1) = interp1([0;tTriang],[0;v],i); % (x,v(x),x_interp)
%             elseif(i>tTriang && i<=ceil(tTriang+tRect))
%                 velArray(i+1) = 50/3.6;
%             else % i>tTriang+tRect
%                 velArray(i+1) = interp1([tTriang+tRect+1;timeArrayLength-1],[v;0],i); % (x,v(x),x_interp)
%             end
%         end
%     end
%     disp('Desired distance: '); disp(distArray(k));
%     disp('speed profile distance sum: '); disp(sum(velArray));
%     if(k>2)
%         velArray = [velArrayOld;velArray];
%     end
%     velArrayOld = velArray;
% end
% 
% timeArray = (1:length(velArray))';
% plot(timeArray,3.6*velArray); title('Speed Profile From Google Maps');
% xlabel('Time [s]'); ylabel('Speed [km/h]');
% 
% percentError = (sum(distArray)-sum(velArray))/(sum(distArray));
% disp('percent Error: '); disp(percentError);

%% make a speed profile from the distance profiles, new version

% Nissan Leaf accelerates 0-100 km/h in 10 s -> desAccel = 2.8 m/s, assume
% a normal desAccel of 1 m/s, find desiredAccel (slope of triangle)

deltaT = 0.1; % time step, do not change this because round fct only works for 0.1 in makeTriangleWithHeight<50() & makeTriangleWithHeight=50()
% also round() in velRectangle

for k=1:length(distArray) % loop through distArray, k==1 (triangle)
    desAccel = getDesiredAccel(distArray,heightArray,k);
    
    tTo50KPH = 50/(3.6*desAccel); % v=v_0 + at -> t = v/a, time required to accelerate to 50 km/h
    if(distArray(k)<(tTo50KPH*50/3.6)) % distance < area of triangle with height 50 km/h
        
        velArray = makeTriangleWithHeightLessThan50KPH(deltaT,desAccel,distArray,k);
%         disp('Make a triangle!');
%         tTo50KPH = sqrt(distArray(k)/desAccel); % A_triang = v_end*tTo50KPH, v=atTo50KPH -> tTo50KPH = sqrt(A/a)
%         disp('tTo50KPH: '); disp(tTo50KPH);
%         v = desAccel*tTo50KPH; % v = v0+at
%         timeLengthTriangle = round(2*tTo50KPH,1); % rounds to nearest 0.1
%         timeArray = (0:0.1:timeLengthTriangle-0.1)'; % intervals of 0.1 sec
%         velArray = zeros(length(timeArray),1);
%         triangleTimeCntr = 0;
%         for i=1:length(velArray) % iterate through vel array              
%             if(triangleTimeCntr<=tTo50KPH) % time <= triangle midpoint time
%                 velArray(i) = interp1([0;round(tTo50KPH,1)],[0;v],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr > round(tTo50KPH,1)
%                 % need to extrapolate to make sure value is not NaN
%             else % time > tTo50KPH
%                 velArray(i) = interp1([round(tTo50KPH,1)+0.1;round(2*tTo50KPH,1)],[v;0],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr < round(tTo50KPH,1)
%                 % need to extrapolate to make sure value is not NaN
%             end
%             triangleTimeCntr = triangleTimeCntr + 0.1;
%         end
%         disp('distance'); disp(distArray(k));
%         disp('area under triangle'); disp(sum(velArray)*0.1);
%         disp('what is k: '); disp(k);
    elseif(distArray(k)==(tTo50KPH*50/3.6)) % distance <= area of triangle with height 50 km/h    
        velArray = makeTriangleWithHeightEqualTo50KPH(deltaT,desAccel,distArray,k);
        
    else % distance > area of triangle with height 50 km/h, make a trapezoid
        disp('make triangle with height 50 from trapezoid');
        [velArrTriangle,tTo50KPH] = makeTriangleWithHeightEqualTo50KPH(deltaT,desAccel,distArray,k);
        areaTriangle = tTo50KPH*(50/3.6);
        [leftSplittedVelTriangle,rightSplittedVelTriangle] = splitTriangleIntoTwoParts(velArrTriangle);
        areaRectangle = distArray(k)-areaTriangle;
        tRectangle = areaRectangle/(50/3.6);
        velRectangle = (50/3.6)*ones(round(tRectangle/deltaT),1);
        velArray = [leftSplittedVelTriangle;velRectangle;rightSplittedVelTriangle];
        disp('velArray Trapezoid distance: '); disp(sum(velArray)*deltaT);
        disp('real distance: '); disp(distArray(k));
        
%         areaRect = distArray(k)-200;
%         tRect = areaRect/(50/3.6);
%         
%         areaTriang = distArray(k)-(50/3.6*tRect);
%         v = 50/3.6;
%         tTriang = areaTriang/v;
%         timeArrayLength = ceil(2*tTriang)+1+ceil(tRect); % rounds up to nearest time
%         timeArray = (0:timeArrayLength-1)';
%         velArray = zeros(timeArrayLength,1);
%         for i=0:timeArrayLength-1
%             if(i<=tTriang)
%                 velArray(i+1) = interp1([0;tTriang],[0;v],i); % (x,v(x),x_interp)
%             elseif(i>tTriang && i<=ceil(tTriang+tRect))
%                 velArray(i+1) = 50/3.6;
%             else % i>tTriang+tRect
%                 velArray(i+1) = interp1([tTriang+tRect+1;timeArrayLength-1],[v;0],i); % (x,v(x),x_interp)
%             end
%         end
%     end
%     disp('Desired distance: '); disp(distArray(k));
%     disp('speed profile distance sum: '); disp(sum(velArray));
%     if(k>2)
%         velArray = [velArrayOld;velArray];
%     end
%     velArrayOld = velArray;
    end
    
    if(k>1)
        velArray = [velArrayOld;velArray];
    end
    velArrayOld = velArray;
    
end

timeArray = (0:0.1:(length(velArray)-1)/10)';
plot(timeArray,3.6*velArray); title('Speed Profile From Google Maps');
xlabel('Time [s]'); ylabel('Speed [km/h]');

disp('Real Distance: '); disp(sum(distArray));
disp('Speed Profile Distance: '); disp(sum(velArray)*deltaT);


%% save timeArray and velArray as text file

% velArrayMPH = 2.23694*velArray; % convert from [m/s] -> [m/hr]
% 
% A = [timeArray'; velArrayMPH'];
% 
% fileID = fopen('/Users/bkvaale/Bjorn/Universities/NTNU/Semester10/RangeEstimation/googleMapsTest.txt','w');
% fprintf(fileID,'%6s %12s\n','GoogleMapsTest.txt','Test Profile');
% fprintf(fileID,'%6s %12s\n','Test Time [s]','Target Speed [mph]');
% fprintf(fileID,'%6.0f\t %12.2f\n',A);
% fclose(fileID);








