function dOCV = dOCVdSoC(OCVAtEvery0Point1PercentSoC,z)
%UNTITLED Summary of this function goes here
%   finds the slope of the OCV function at the given z, uses midpoint rule
%   to find derivative, OCV given in V, z given in decimal form (not %)
    %figure(1);
    %plot(0:0.1:100,OCVAtEvery0Point1PercentSoC); xlabel('SoC [%]'); ylabel('OCV [V]');
    
    if(100*z>=99.9)
        zPercent = 99.9; % max SoC = 100%
    elseif(100*z<=0.1)
        zPercent = 0.1; % min SoC = 0%
    else % 0.1<z<99.9
        zPercent = round(100*z,1); % given in [%], round to one digit to right of decimal point
    end
    
    %disp('zPercent'); disp(zPercent);
    
    zDown = zPercent-0.1; %disp('zDown'); disp(zDown);
    zUp = zPercent+0.1;
    
    SoC = 0:0.1:100;
    zDownIndex = find(abs(SoC-zDown) < 0.001); % use tolerance value, otherwise could return empty matrix because of rounding error
    %disp('zDownIndex'); disp(zDownIndex);
    zUpIndex = find(abs(SoC-zUp) < 0.001); % use tolerance value, otherwise could return empty matrix because of rounding error
    %disp('zUpIndex'); disp(zUpIndex);
    
    OCVDown = OCVAtEvery0Point1PercentSoC(zDownIndex);
    OCVUp = OCVAtEvery0Point1PercentSoC(zUpIndex);
    
    dOCV = (OCVUp-OCVDown)/(0.01*(zUp-zDown)); % zUp & zDown should be in decimal form, not in [%]
    
    %% Old Code
%     if(rem(zPercent,1)==0) % zPercent an integer value
%         % need to add a small value so that floor & ceil give different
%         % answers
%         zPercent = zPercent + 1e-4;
%     end
%     
%     zDown = floor(zPercent); % nearest integer, 2.6 -> 2
%     zUp = ceil(zPercent); % nearest integer, 2.4 -> 3 
% %     disp('zDown'); disp(zDown);
% %     disp('zUp'); disp(zUp);
%     OCVDown = OCVAtEvery0Point1PercentSoC(zDown+1);
%     OCVUp = OCVAtEvery0Point1PercentSoC(zUp+1);
% %     disp('OCVDown'); disp(OCVDown);
% %     disp('OCVUp'); disp(OCVUp);
%     dOCV = (OCVUp-OCVDown)/(zUp-zDown);
end

