function OCVAtZk = findOCVAtZk(OCVAtEvery0Point1PercentSoC,z)
%   interpolates OCV for a given z, if z<0 or z>100 -> returns vmin or vmax
    if(z>=0 && z<=1) % z must be between 0% and 100%
        zPercent = round(100*z,1); % given in [%], round to one digit to right of decimal point
        %disp('zPercent'); disp(zPercent);
        SoC = 0:0.1:100; % SoC from 0% -> 100%
        SoC = SoC';
        %index = find(SoC == round(100*z)); % finds index position of z in SoC array
        index = find(abs(SoC-zPercent) < 0.001); % finds index position of z in SoC array
        %disp('Index: '); disp(index);
        %disp('length: '); disp(length(index));
        if(length(index)) % if length = 1 -> index was found, do not need to interpolate
            %disp('do not need to interpolate');
            OCVAtZk = OCVAtEvery0Point1PercentSoC(index);
        else % z was not found, need to interpolate
            disp('need to interpolate');
            OCVAtZk = interp1(SoC,OCVAtEvery0Point1PercentSoC,zPercent);
        end
    else % z<0% or z>100%
        if(z<0)
           disp('SoC<0%, use vmin');
           OCVAtZk = OCVAtEvery0Point1PercentSoC(1);
        else % z>100%
           disp('SoC>100%, use vmax');
           OCVAtZk = OCVAtEvery0Point1PercentSoC(end);
        end
    end  
end

