function speedProfile = findLowestEnergySpeedProfile(distance,distanceCntr,distanceToStartUsingAccurateSpeeds,deltaT,gradeAsDecimal,actualSpeed,recCntr,recLimit,speedLimit,vehicle)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
    
    distanceCntr = distanceCntr + actualSpeed*deltaT;
    %fprintf('DistanceCntr is: %f  prevSpeed is: %f grade is: %f \n',distanceCntr,prevActualSpeed,gradeAsDecimal);

    if(abs(distance-distanceCntr) < 2 && actualSpeed == 0) % found a speed profile that works
        disp('Found a speed profile!');
        fprintf('Found a speed profile, recCntr is: %d \n',recCntr);
        speedProfile = zeros(recCntr,1);
        speedProfile(recCntr) = actualSpeed;
        return;
    elseif distanceCntr > distance
        %disp('Speed profile distance too long!');
        speedProfile = 1;
        return; % exits current function, goes back to last recursive call to fct in for loop below
    elseif recCntr > recLimit
        %disp('Speed profile too long!');
        speedProfile = 1;
        return;
    elseif(recCntr == recLimit && distanceCntr < distance)
        %disp('speed profile not accurate enough');
        %fprintf('speed profile not accurate enough, distance-distanceCntr is: %f \n',abs(distance-distanceCntr));
        speedProfile = 1;
        return;
    else
        %disp('else was called!');
        [minSpeed,maxSpeed] = getMinAndMaxSpeedsFromMaxTorqueAndMaxRegenBraking(deltaT,gradeAsDecimal,actualSpeed,speedLimit,vehicle);
        %fprintf('minSpeed: %f , maxSpeed: %f \n',minSpeed,maxSpeed);
        if(abs(distance-distanceCntr) < distanceToStartUsingAccurateSpeeds) % vehicle will start to slow down
            %fprintf('distance < 30 is: %f \n',abs(distance-distanceCntr));
            %speeds = (minSpeed:0.1:maxSpeed)';
            speeds = (minSpeed:0.1:actualSpeed)'; % car cannot accelerate anymore
            speeds = fliplr(speeds);
        else
            speeds = maxSpeed;
            %speeds = [minSpeed maxSpeed]';
        end

        for i=1:length(speeds)

            speedProfile = findLowestEnergySpeedProfile(distance,distanceCntr,distanceToStartUsingAccurateSpeeds,deltaT,gradeAsDecimal,speeds(i),recCntr+1,recLimit,speedLimit,vehicle);
%             if(length(speedProfile)==1)
%                 disp('speedProfile: ');
%                 disp(speedProfile);
%             else
%                 disp('speedProfile length > 1');
%             end
            if(length(speedProfile) == 1 && (speedProfile == 1 || speedProfile == 0)) % speed profile distance or speed profile too long
                %disp('speed profile = 0 or 1');
                speedProfile = 0; % reset speed profile
                %break; % breaks from for loop
            else % working speed profile
                disp('Working speed profile found!');
                %fprintf('recCntr: %d \n',recCntr);
                if(recCntr>1) % recCntr initialized at 2
                    %fprintf('speed profile added: %f with recCntr: %d \n',speeds(i),recCntr);
                    speedProfile(recCntr) = speeds(i);
                end
                return; % goes back to last recursive call to fct in for loop below
            end
        end
    end
end

