function limSpeedSIUnits = getLimSpeedFromMaxTorqueIter(deltaT,gradeAsDecimal,speedLimitInSIUnits,vehicle)
%GETLIMSPEEDFROMMAXTORQUE Summary of this function goes here
%   Detailed explanation goes here

    persistent prevLimSpeed;

    if(isempty(prevLimSpeed)) % need to initialize persistent variables
        prevLimSpeed = 0; % vehicle speed, [m/s]
    end

%     if(abs(prevLimMotorSpeedRPM)>=0 && abs(prevLimMotorSpeedRPM)<=vehicle.drivetrain.motor.ratedRPM) % straight line of torque vs speed curve
%         maxMotorTorque = vehicle.drivetrain.motor.maxRatedTorque; % max motor torque is equal to straight line value
%     else % rated RPM < demanded motor torque <= max motor RPM, actual motor speed limited in a later equation
%         maxMotorTorque = vehicle.drivetrain.motor.maxRatedTorque*(vehicle.drivetrain.motor.ratedRPM/prevLimMotorSpeedRPM);
%     end

    maxMotorTorque = vehicle.drivetrain.motor.maxRatedTorque/10; % max motor torque is equal to straight line value
% change this later!!!
    
    %maxRegenMotorTorque = -min(maxMotorTorque,vehicle.drivetrain.motor.regenFraction*vehicle.drivetrain.motor.maxRatedTorque);

    rho_air = 1.225; % [kg/m^3], air density at 0^o C and 1 atm, see wikipedia, density of air
    %disp('prevActualSpeed: '); disp(prevActualSpeed);
    aeroForce = 0.5*rho_air*vehicle.frontalArea*vehicle.Cd*(prevLimSpeed^2); % rho_air: air density, Cd: drag coefficient
    fprintf('aero force is: %f \n',aeroForce);
    g = 9.81; % [m/s^2]

    if(abs(prevLimSpeed)>1e-15) % do not use desired speed because it could be the motor cannot achieve that speed, assume very small
        % speeds do not have a rolling force!
       rollingForce = vehicle.wheel.Cr*vehicle.maxVehicleMass*g; % [N]
       fprintf('rolling force is: %f \n',rollingForce);
    else
       rollingForce = 0; % [N] 
    end

    gradeAngleInRads = atan(gradeAsDecimal);
    gradeForce = vehicle.maxVehicleMass*g*sin(gradeAngleInRads); % gradeAngleInRads: slope of road, incline: positive, descent: negative
    fprintf('grade force is: %f \n',gradeForce);
    
    brakeDrag = 0; % assume no frictional losses from brakes
    
    desAccelForce = (vehicle.drivetrain.N/vehicle.wheel.radius)*maxMotorTorque - aeroForce - rollingForce - gradeForce - brakeDrag;

    desAccel = desAccelForce/vehicle.equivMass; % desired acceleration force [m/s]

    desSpeedSI = desAccel*deltaT + prevLimSpeed;
    fprintf('Desired acceleration is: %f \n',desAccel);

    limSpeedSIUnits = min(desSpeedSI,speedLimitInSIUnits); % car should not travel faster than speed limit
    prevLimSpeed = limSpeedSIUnits;
    fprintf('Lim Speed in km/h is: %f \n',limSpeedSIUnits*3.6);

end

