function distArrayMeters = getRouteDistancesFromTextFile(textFileName,numDistanceLines)
%getRouteDistancesFromTextFile
%   first input origin & destination into Google Maps, save the pdf,
%   convert to text file, this function reads the text file
% input: text file name as a string, routes found in testRoutes folder
% output: the route distances
%% import text file & save important distances in a distance array [meters]


disp(textFileName);
fileID = fopen(textFileName); % open text file
currLine = 'a'; % makes sure while loop runs first time
%numDistanceLines = 10000; % put as input argument next!!
distArrayMeters = zeros(numDistanceLines,1); % used to fill up distances
numUsefulLinesCntr = 1;

while ischar(currLine)
    currLine = fgetl(fileID); % outputs current line from text file
    %disp(currLine);
    
    if(length(currLine)>3 && isstrprop(currLine(end-3),'digit') && isspace(currLine(end-2)) && strcmp(currLine(end-1),'k') && strcmp(currLine(end),'m')) % e.g. 15.1 km contains digit 1, then whitespace, then k, then m 
        %disp('currLine: '); disp(currLine);
        currLineIntInMeters = stringDistToIntDistInMeters(currLine);
        distArrayMeters(numUsefulLinesCntr) = currLineIntInMeters;
        %disp('currLine as int: '); disp(currLineIntInMeters);
        numUsefulLinesCntr=numUsefulLinesCntr+1;
    elseif(length(currLine)>2 && isstrprop(currLine(end-2),'digit') && isspace(currLine(end-1)) && strcmp(currLine(end),'m')) % e.g. 15.1 km contains digit 1, then whitespace, then k, then m 
        %disp('currLine: '); disp(currLine);
        currLineIntInMeters = stringDistToIntDistInMeters(currLine);
        distArrayMeters(numUsefulLinesCntr) = currLineIntInMeters;
        %disp('currLine as int: '); disp(currLineIntInMeters);
        numUsefulLinesCntr=numUsefulLinesCntr+1;
    end
end

fclose(fileID);

distArrayMeters = distArrayMeters(1:numUsefulLinesCntr-1);

end

