% %% import text file & save important distances in an int array
% fileID = 'elevationTest/waediToEinsiedelnElevationTest.txt'; % open text file
% inputTxt = textscan(fileID,'%*s %*f32 %*f32 %f32 %f32 %*f32','Delimiter','\t'); % reads columns altitude & distance, * hides columns, single precision floating point number
% fclose('all'); % fclose(fileID) gives an error
% %celldisp(inputTxt);
% 
% inputTxtChar = inputTxt{1};
% len = length(inputTxtChar);
% distance = ''; % initialize a string that will hold all of the distance information
% distanceVal = ''; % initialize values that will be added to distance string




%% import GPS visualizer text file & save elevation & distances in two separate arrays
% need to remove first 5 lines for it to work !!, might want to fix this
% later
clc; clear; close all;

%file = {'elevationTest/medellinToBogotaScanf.txt','elevationTest/greymouthToChristchurchScanf.txt','elevationTest/waediToEinsiedelnScanf.txt'};
file = {'elevationTest/medellinToBogotaScanf.txt','elevationTest/bogotaToLaDoradoScanf.txt','elevationTest/waediToEinsiedelnScanf.txt'};


for elevationTest=2:2%elevationTest=1:length(file)

    fileID = fopen(file{elevationTest}); % open text file
    %fileID = fopen('elevationTest/greymouthToChristchurchScanf.txt'); % open text file
    %fileID = fopen('elevationTest/waediToEinsiedelnScanf.txt'); % open text file


    scannedTxt = textscan(fileID,'%*c %*f32 %*f32 %d32 %f32 %*d16 %*s %*s','Delimiter','\t'); % reads columns altitude & distance, * hides columns, single precision floating point number
    % %f32 is single precision floating point number, %d16 is 16-bit unsigned
    % integer, 2^16 = 65536 numbers
    fclose('all'); % fclose(fileID) gives an error
    %celldisp(inputTxt);

    elevationGPSPoints = scannedTxt{1}; % [m], need to make this 32 bit signed to use / (division) below
    distanceGPSPoints = int32(1000*scannedTxt{2}); % [m], 16 bit signed integer, -2^15 to 2^15-1
    % need to convert here and not in textscan because you lose precision when
    % rounding before converting from km to meters


    %% elevationGPSPoints to Grade Angle [%]

    % gradeAngleInPercent = zeros(length(elevationGPSPoints),1);
    % 
    % for i=1:length(gradeAngleInPercent)
    %     if(i<length(gradeAngleInPercent))
    %         rise = elevationGPSPoints(i+1)-elevationGPSPoints(i);
    %         run = distanceGPSPoints(i+1)-distanceGPSPoints(i);
    %         gradeAngleInPercent(i) = rise/run;
    %     end
    % end
    % 
    % figure(1); plot(gradeAngleInPercent);

    %% old code below

    %% import Google Maps Route information from text file

%     textFileName = 'testRoutes/medellinToBogota.txt';
    %textFileName = 'testRoutes/greymouthToChristchurch.txt'; % bug in this test, forgets to include one distance
    %textFileName = 'testRoutes/waediToEinsiedeln.txt';

    textFileName = {'testRoutes/medellinToBogota.txt','testRoutes/bogotaToLaDorado.txt','testRoutes/waediToEinsiedeln.txt'};
    
    numDistanceLines = 10000;
    deltaGoogleMapsWaypointDistances = getRouteDistancesFromTextFile(textFileName{elevationTest},numDistanceLines); % next distance - curr distance

    googleMapsWaypointDistances = zeros(length(deltaGoogleMapsWaypointDistances)+1,1); % how far away the next direction points are from 0

    for i=1:length(googleMapsWaypointDistances)
        if(i>1)
            googleMapsWaypointDistances(i) = googleMapsWaypointDistances(i-1) + deltaGoogleMapsWaypointDistances(i-1);
        end
    end

    %% interpolate elevation for Google Maps waypoints (given distance) from GPS Visualizer waypoints (given distance & elevation)
    %disp([googleMapsWaypointDistances(1:10) distanceGPSPoints(1:10)]);

    % store 

    resolution = 100; % want distance & elevation info for every 100 meters starting from 0, also include google maps waypoint distances

    googleMapsWaypointDistancesHighRes = increaseDistanceArrayResolution(googleMapsWaypointDistances,resolution);

    %googleMapsWaypointDistancesHighRes(1:20)

    googleMapsWaypointElevationHighRes = zeros(size(googleMapsWaypointDistancesHighRes)); % stores a struct in each cell, [m]

    disp('Print');
    
    distanceGPSPointsCntr=1; % do not want to start at beginning of distanceGPSPoints each time
    for i=1:length(googleMapsWaypointDistancesHighRes)
        for j=distanceGPSPointsCntr:length(distanceGPSPoints)
            if(googleMapsWaypointDistancesHighRes(i)==distanceGPSPoints(j)) 
                googleMapsWaypointElevationHighRes(i) = elevationGPSPoints(j);    
                %fprintf('GM distance: %d , GPS point: %d , elevation: %d \n',googleMapsWaypointDistancesHighRes(i),distanceGPSPoints(j),googleMapsWaypointElevationHighRes(i));
                distanceGPSPointsCntr = j+1; % start next iteration at next GPS point
                break;
            elseif(googleMapsWaypointDistancesHighRes(i) < distanceGPSPoints(j) && googleMapsWaypointDistancesHighRes(i) > distanceGPSPoints(j-1)) % GM waypoint should be between two GPS waypoints
                e1 = elevationGPSPoints(j-1); e2 = elevationGPSPoints(j); % elevation of two different points
                d1 = distanceGPSPoints(j-1); d2 = distanceGPSPoints(j); % distance of two different points
                di = googleMapsWaypointDistancesHighRes(i); % distance at which elevation should be interpolated
                m = (e2-e1)/(d2-d1); % slope of straight line between two points with (d1,e1), (d2,e2)
                googleMapsWaypointElevationHighRes(i) = m*di + (e1-m*d1); % linear interpolation
                %fprintf('GM distance: %d, GPS prev: %d, GPS next: %d,  \n', googleMapsWaypointDistancesHighRes(i),distanceGPSPoints(j-1),distanceGPSPoints(j));
                distanceGPSPointsCntr = j; % could be another Google Maps waypoint < current distanceGPSPoint
                break;
            elseif(googleMapsWaypointDistancesHighRes(i) > distanceGPSPoints(j))
                dist = single(distanceGPSPoints(end-5:end)); % extrapolate using last 5 GPS distance & elevation waypoints, needs to be casted to single for interp1 to work
                elev = single(elevationGPSPoints(end-5:end)); % elev(dist), needs to be casted to single for interp1 to work
                distExtrap = googleMapsWaypointDistancesHighRes(i); % distance point to extrapolate elevation from
                fprintf('dist: %5.3f elev: %5.3f distExtrap: %5.3f \n', dist,elev,distExtrap);
                googleMapsWaypointElevationHighRes(i) = interp1(dist,elev,distExtrap,'linear','extrap');
            end
        end
    end
    %figure(1); plot(distanceGPSPoints/1000,elevationGPSPoints);
%     figure(1); plot(distanceGPSPoints/1000,elevationGPSPoints,googleMapsWaypointDistancesHighRes/1000,googleMapsWaypointElevationHighRes);
    %figure(1); plot(distanceGPSPoints/1000,elevationGPSPoints,googleMapsWaypointDistances/1000,googleMapsWaypointElevation);
%     legend('GPS Visualizer Elevation Data','Google Maps Waypoints'); xlabel('Route Distance [km]'); ylabel('Elevation [m]'); title('Medellin To Bogota Elevation Profile');

    %disp([distanceGPSPoints(end-5:end) googleMapsWaypointDistancesHighRes(end-5:end)]);

    %% find grade angle in percent

    gradeAngleInPercent = zeros(length(googleMapsWaypointElevationHighRes),1);

    for i=1:length(googleMapsWaypointElevationHighRes)
        if(i<length(googleMapsWaypointElevationHighRes))
            rise = googleMapsWaypointElevationHighRes(i+1)-googleMapsWaypointElevationHighRes(i);
            run = googleMapsWaypointDistancesHighRes(i+1)-googleMapsWaypointDistancesHighRes(i);
            gradeAngleInPercent(i) = atan(rise/run)*100;
        end
    end

%     figure(1); plot(gradeAngleInPercent);
    result = struct('distance',googleMapsWaypointDistancesHighRes,'elevation',googleMapsWaypointElevationHighRes,'gradeAngle',gradeAngleInPercent);
    results{elevationTest} = result;
%     figure(2); hist(gradeAngleInPercent,20); % 10 bins
%     xlabel('Grade Angle In Percent Value'); ylabel('Frequency'); title('Histogram of Grade Angle In Percent');


end
%% plot

    figure(1); plot(results{1}.distance,results{1}.elevation);
    xlabel('Distance [m]'); ylabel('Elevation [m]'); title('Elevation Profile Medellin To Bogota');
    figure(2); plot(results{2}.distance,results{2}.elevation);
    xlabel('Distance [m]'); ylabel('Elevation [m]'); title('Elevation Profile Greymouth To Christchurch');
    figure(3); plot(results{3}.distance,results{3}.elevation);
    xlabel('Distance [m]'); ylabel('Elevation [m]'); title('Elevation Profile Waedenswil To Einsiedeln');
    figure(4); hist(results{1}.gradeAngle,20); % 10 bins
    xlabel('Grade Angle In Percent Value'); ylabel('Frequency'); title('Grade Angle Histogram Medellin To Bogota');
    figure(5); hist(results{2}.gradeAngle,20); % 10 bins
    xlabel('Grade Angle In Percent Value'); ylabel('Frequency'); title('Grade Angle Histogram Greymouth To Christchurch');
    figure(6); hist(results{3}.gradeAngle,20); % 10 bins
    xlabel('Grade Angle In Percent Value'); ylabel('Frequency'); title('Grade Angle Histogram Waedenswil To Einsiedeln');
    figure(7); plot(results{1}.gradeAngle);
    xlabel('Distance [km]'); ylabel('Grade Angle [%]'); title('Grade Angle Medellin To Bogota');
    figure(8); plot(results{2}.gradeAngle);
    xlabel('Distance [km]'); ylabel('Grade Angle [%]'); title('Grade Angle Greymouth To Christchurch');
    figure(9); plot(results{3}.gradeAngle);
    xlabel('Distance [km]'); ylabel('Grade Angle [%]'); title('Grade Angle Waedenswil To Einsiedeln');
%% calculate mean and std. dev. for three profiles

fprintf('Mean Medellin: %3.2f , std dev: %3.2f \n',mean(results{1}.gradeAngle),std(results{1}.gradeAngle));
fprintf('Mean Greymouth: %3.2f , std dev: %3.2f \n',mean(results{2}.gradeAngle),std(results{2}.gradeAngle));
fprintf('Mean Waedi: %3.2f , std dev: %3.2f \n',mean(results{3}.gradeAngle),std(results{3}.gradeAngle));


%%

% clc; clear;
% 
% %fileID = 'elevationTest/samfundetToOsloElevationTest.txt'; % open text file
% %fileID = 'elevationTest/waediToEinsiedelnElevationTest.txt'; % open text file
% fileID = 'elevationTest/greymouthToChristchurchTest.txt'; % open text file
% %fileID = 'elevationTest/medellinToBogotaElevationTest.txt';
% 
% % R1 = 5; % row offset, start reading at test time 0, skip headers
% % C1 = 3; % column offset, reads altitude [m]
% % R2 = 5; % only read first row, problem with origin (e.g. Waedenswil) - destination (i.e. Einsiedeln) in txt file
% % C2 = 4; % reads distance [km]
% % 
% % outputMatrixFirstRow = dlmread(fileID,'\t',[R1 C1 R2 C2]); % format [test time in seconds, test speed in mph], tab deliminator
% 
% R1 = 6; % row offset, start reading at test time 0, skip headers
% C1 = 3; % column offset, reads altitude [m]
% outputMatrixOtherRows = dlmread(fileID,'\t',R1,C1); % format [test time in seconds, test speed in mph], tab deliminator
% altitude = outputMatrixOtherRows(:,1);
% distance = outputMatrixOtherRows(:,2);
% %clear outputMatrixOtherRows;

%%

p = genpath('/Users/bkvaale/Bjorn/Universities/NTNU/Semester10/GoogleMapsToSpeedProfile/RangeEstimationGP'); % include RangeEstimationGP & subfolders to search path
% needed to be able to use setup functions located in RangeEstimationGP
addpath(p); % add to search path

% setup cell
capacity = 15; % [Ah], change capacity
%capacity = Q_est/3600; % [Ah]
vcurrent = 4.2; % [V], start at max voltage
vnom = 3.8; % [V]
weight = 0.45; % [kg]
battCell = setupCell(capacity,vcurrent,vnom,weight);
    
% setup module
numParallel = 3; % number of cells in parallel in one module
numSeries = 8; % number of cells in series in one module
overhead = 0.08; % overhead by weight ???
module = setupModule(battCell,numParallel,numSeries,overhead);

% setup pack
efficiency = 0.96; % [unitless]
emptySoC = 25; % [%]
fullSoC = 75; % [%]
numSeries = 12; % number of modules in series in one battery pack
overhead = 0.1; % overhead by weight ???
pack = setupPack(efficiency,emptySoC,fullSoC,module,numSeries,overhead);

% setup motor
inertia = 0.2; % kg/m^2
maxRatedRPM = 12000; % [RPM]
maxRatedTorque = 275; % [Nm]
ratedRPM = 4000; % [RPM]
regenFraction = 0.9; % drivetrain.regenTorque in GP setupSimVehicle.m
efficiency = 0.95; % [unitless]
motor = setupMotor(efficiency,inertia,maxRatedRPM,maxRatedTorque,ratedRPM,regenFraction);

% setup drivetrain
gearboxInertia = 0.05; % [kg/m^2]
gearEfficiency = 0.97; % [unitless]
gearRatio = 12;
inverterEfficiency = 0.94;
drivetrain = setupDrivetrain(gearboxInertia,gearEfficiency,gearRatio,inverterEfficiency,motor,pack);

% setup wheel
Cr = 0.0111; % rolling coefficient
radius = 0.35; % [m]
inertia = 8; % [kg/m^2]
wheel = setupWheel(Cr,inertia,radius);

% setup vehicle
Cd = 0.22; % drag coefficient, probably more like 0.285
frontalArea = 1.84; % [m^2], 2.14 m^2 for 2014 chevy volt
overheadPower = 0.2; % [kW]
numWheels = 4;
payload = 75; % [kg], could increase this to 390 kg
weight = 1425; % [kg], 1721 kg
vehicle = setupVehicle(Cd,drivetrain,frontalArea,motor,numWheels,overheadPower,payload,weight,wheel);

% deltaT = 1; % find limited speed every 0.1 seconds
% %speedLimitInSIUnits = 50/3.6; % [m/s]
% limActualSpeedSIUnits = zeros(size(googleMapsWaypointElevationHighRes));
% 
% % load('paramEstimationOutput.mat'); % includes 'timeEKF','iEKF','vEKF','trueSoC','OCVAtEvery0Point1PercentSoC','thetaHatPlus','eta_25','Q_est'
% % clear timeEKF iEKF vEKF trueSoC thetaHatPlus eta_25 Q_est; % not needed
% 
% for i=1:length(googleMapsWaypointElevationHighRes)
%     if(i==1)
%         gradeAsDecimal = 0; % [%]
%     else % i>1
%         rise = googleMapsWaypointElevationHighRes(i) - googleMapsWaypointElevationHighRes(i-1);
%         run = googleMapsWaypointDistancesHighRes(i) - googleMapsWaypointDistancesHighRes(i-1);
%         gradeAsDecimal = rise/run*100;
%     end
%     %limSpeedSIUnits(i) = getLimSpeedFromMaxTorqueIter(deltaT,gradeAsDecimal,speedLimitInSIUnits,vehicle);
% 
% end

%% test
clc; 
distance = 1500; % assume distance ? 20, round up distances to nearest multiple of 10
distanceCntr = 0; deltaT = 1; gradeAsDecimal = 0.1; % steepest road grade in the world
actualSpeed = 0; recCntr = 2; % always start recCntr at 2 because the first speed will be 0
speedLimit = 50/3.6; % [km/h] -> [m/s]

if(distance==10)
    distanceToStartUsingAccurateSpeeds = 9;
    recLimit = 10;
elseif(distance==20)
    distanceToStartUsingAccurateSpeeds = 19;
    recLimit = 10;
elseif(distance==30)
    distanceToStartUsingAccurateSpeeds = 30;
    recLimit = 100;
elseif(distance==40)
    distanceToStartUsingAccurateSpeeds = 30;
    recLimit = 100;
elseif(distance==50)
    distanceToStartUsingAccurateSpeeds = 30;
    recLimit = 100;
else % distance > 50
    distanceToStartUsingAccurateSpeeds = 30;
    recLimit = 100;
end

% if(distance<20)
%     distanceToStartUsingAccurateSpeeds = 6;
%     recLimit = 15;
% elseif(distance < 40 && distance>=20)
%     distanceToStartUsingAccurateSpeeds = 19;
%     recLimit = 20;
% elseif(distance < 60 && distance>=40)
%     distanceToStartUsingAccurateSpeeds = 30;
%     recLimit = 100;
% elseif(distance < 80 && distance>=60)
%     distanceToStartUsingAccurateSpeeds = 30;
%     recLimit = 100;
% elseif(distance < 100 && distance>=80)
%     distanceToStartUsingAccurateSpeeds = 30;
%     recLimit = 100;
% else % distance >= 100
%     distanceToStartUsingAccurateSpeeds = 30;
%     recLimit = 100;
% end

% if(distance<30)
%     distanceToStartUsingAccurateSpeeds = 15;
% elseif(distance < 100 && distance>=30)
%     distanceToStartUsingAccurateSpeeds = 30;
% else % 30 <= distance <= 50
%     distanceToStartUsingAccurateSpeeds = distance/2;
% end

%gradeAsDecimal = findGradeAsDecimal(distance,distanceCntr,elevation);
tic
speedProfile = findLowestEnergySpeedProfile(distance,distanceCntr,distanceToStartUsingAccurateSpeeds,deltaT,gradeAsDecimal,actualSpeed,recCntr,recLimit,speedLimit,vehicle);
toc

figure(3); plot(speedProfile); xlabel('Time [s]'); ylabel('Speed [m/s]');
%% make a speed profile from the distance profiles, new version

% Nissan Leaf accelerates 0-100 km/h in 10 s -> desAccel = 2.8 m/s, assume
% a normal desAccel of 1 m/s, find desiredAccel (slope of triangle)

% deltaT = 0.1; % time step, do not change this because round fct only works for 0.1 in makeTriangleWithHeight<50() & makeTriangleWithHeight=50()
% % also round() in velRectangle
% 
% for k=1:length(distArray) % loop through distArray, k==1 (triangle)
%     desAccel = getDesiredAccel(distArray,heightArray,k);
%     
%     tTo50KPH = 50/(3.6*desAccel); % v=v_0 + at -> t = v/a, time required to accelerate to 50 km/h
%     if(distArray(k)<(tTo50KPH*50/3.6)) % distance < area of triangle with height 50 km/h
%         
%         velArray = makeTriangleWithHeightLessThan50KPH(deltaT,desAccel,distArray,k);
% %         disp('Make a triangle!');
% %         tTo50KPH = sqrt(distArray(k)/desAccel); % A_triang = v_end*tTo50KPH, v=atTo50KPH -> tTo50KPH = sqrt(A/a)
% %         disp('tTo50KPH: '); disp(tTo50KPH);
% %         v = desAccel*tTo50KPH; % v = v0+at
% %         timeLengthTriangle = round(2*tTo50KPH,1); % rounds to nearest 0.1
% %         timeArray = (0:0.1:timeLengthTriangle-0.1)'; % intervals of 0.1 sec
% %         velArray = zeros(length(timeArray),1);
% %         triangleTimeCntr = 0;
% %         for i=1:length(velArray) % iterate through vel array              
% %             if(triangleTimeCntr<=tTo50KPH) % time <= triangle midpoint time
% %                 velArray(i) = interp1([0;round(tTo50KPH,1)],[0;v],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr > round(tTo50KPH,1)
% %                 % need to extrapolate to make sure value is not NaN
% %             else % time > tTo50KPH
% %                 velArray(i) = interp1([round(tTo50KPH,1)+0.1;round(2*tTo50KPH,1)],[v;0],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr < round(tTo50KPH,1)
% %                 % need to extrapolate to make sure value is not NaN
% %             end
% %             triangleTimeCntr = triangleTimeCntr + 0.1;
% %         end
% %         disp('distance'); disp(distArray(k));
% %         disp('area under triangle'); disp(sum(velArray)*0.1);
% %         disp('what is k: '); disp(k);
%     elseif(distArray(k)==(tTo50KPH*50/3.6)) % distance <= area of triangle with height 50 km/h    
%         velArray = makeTriangleWithHeightEqualTo50KPH(deltaT,desAccel,distArray,k);
%         
%     else % distance > area of triangle with height 50 km/h, make a trapezoid
%         disp('make triangle with height 50 from trapezoid');
%         [velArrTriangle,tTo50KPH] = makeTriangleWithHeightEqualTo50KPH(deltaT,desAccel,distArray,k);
%         areaTriangle = tTo50KPH*(50/3.6);
%         [leftSplittedVelTriangle,rightSplittedVelTriangle] = splitTriangleIntoTwoParts(velArrTriangle);
%         areaRectangle = distArray(k)-areaTriangle;
%         tRectangle = areaRectangle/(50/3.6);
%         velRectangle = (50/3.6)*ones(round(tRectangle/deltaT),1);
%         velArray = [leftSplittedVelTriangle;velRectangle;rightSplittedVelTriangle];
%         disp('velArray Trapezoid distance: '); disp(sum(velArray)*deltaT);
%         disp('real distance: '); disp(distArray(k));
%         
% %         areaRect = distArray(k)-200;
% %         tRect = areaRect/(50/3.6);
% %         
% %         areaTriang = distArray(k)-(50/3.6*tRect);
% %         v = 50/3.6;
% %         tTriang = areaTriang/v;
% %         timeArrayLength = ceil(2*tTriang)+1+ceil(tRect); % rounds up to nearest time
% %         timeArray = (0:timeArrayLength-1)';
% %         velArray = zeros(timeArrayLength,1);
% %         for i=0:timeArrayLength-1
% %             if(i<=tTriang)
% %                 velArray(i+1) = interp1([0;tTriang],[0;v],i); % (x,v(x),x_interp)
% %             elseif(i>tTriang && i<=ceil(tTriang+tRect))
% %                 velArray(i+1) = 50/3.6;
% %             else % i>tTriang+tRect
% %                 velArray(i+1) = interp1([tTriang+tRect+1;timeArrayLength-1],[v;0],i); % (x,v(x),x_interp)
% %             end
% %         end
% %     end
% %     disp('Desired distance: '); disp(distArray(k));
% %     disp('speed profile distance sum: '); disp(sum(velArray));
% %     if(k>2)
% %         velArray = [velArrayOld;velArray];
% %     end
% %     velArrayOld = velArray;
%     end
%     
%     if(k>1)
%         velArray = [velArrayOld;velArray];
%     end
%     velArrayOld = velArray;
%     
% end
% 
% timeArray = (0:0.1:(length(velArray)-1)/10)';
% plot(timeArray,3.6*velArray); title('Speed Profile From Google Maps');
% xlabel('Time [s]'); ylabel('Speed [km/h]');
% 
% disp('Real Distance: '); disp(sum(distArray));
% disp('Speed Profile Distance: '); disp(sum(velArray)*deltaT);


%% save timeArray and velArray as text file

% velArrayMPH = 2.23694*velArray; % convert from [m/s] -> [m/hr]
% 
% A = [timeArray'; velArrayMPH'];
% 
% fileID = fopen('/Users/bkvaale/Bjorn/Universities/NTNU/Semester10/RangeEstimation/googleMapsTest.txt','w');
% fprintf(fileID,'%6s %12s\n','GoogleMapsTest.txt','Test Profile');
% fprintf(fileID,'%6s %12s\n','Test Time [s]','Target Speed [mph]');
% fprintf(fileID,'%6.0f\t %12.2f\n',A);
% fclose(fileID);








