function googleMapsWaypointDistancesHighRes = increaseDistanceArrayResolution(googleMapsWaypointDistances,resolution)
%INCREASEDISTANCEARRAYRESOLUTION inputs an array with increasing distances & a
% preferred increase in resolution, outputs an array that includes the
% input array with some higher resolution points in between
% Example: input array = [0 12 14 25 30 50 65], resolution = 10 -> 
% resolution array = [0 10 20 30 40 50 60]
% combine input with resolution array -> output array = [0 10 12 14 20 25 30 40 50 60 65]

    distanceEveryResolutionMeters = 0:resolution:googleMapsWaypointDistances(end);
    googleMapsWaypointDistancesHighRes = zeros(length(googleMapsWaypointDistances)+length(distanceEveryResolutionMeters),1);

    googleMapsWaypointDistancesCntr=1; % to loop through googleMapsWaypointDistances array
    distanceEveryResolutionMetersCntr=1; % to loop through distanceEveryResolutionMeters array
    howManyVectorValuesAreEqualCntr=0;

    for i=1:length(googleMapsWaypointDistancesHighRes)
        %disp('Hello!')
        if(distanceEveryResolutionMetersCntr>length(distanceEveryResolutionMeters) && googleMapsWaypointDistancesCntr>length(googleMapsWaypointDistances))
            break; % looped through both arrays, break from for loop
        elseif(distanceEveryResolutionMetersCntr>length(distanceEveryResolutionMeters) || googleMapsWaypointDistances(googleMapsWaypointDistancesCntr) < distanceEveryResolutionMeters(distanceEveryResolutionMetersCntr)) 
           googleMapsWaypointDistancesHighRes(i) = googleMapsWaypointDistances(googleMapsWaypointDistancesCntr);
           googleMapsWaypointDistancesCntr = googleMapsWaypointDistancesCntr + 1;
        elseif(googleMapsWaypointDistancesCntr>length(googleMapsWaypointDistances) || googleMapsWaypointDistances(googleMapsWaypointDistancesCntr) > distanceEveryResolutionMeters(distanceEveryResolutionMetersCntr))
           googleMapsWaypointDistancesHighRes(i) = distanceEveryResolutionMeters(distanceEveryResolutionMetersCntr);
           distanceEveryResolutionMetersCntr = distanceEveryResolutionMetersCntr + 1;
        elseif(googleMapsWaypointDistances(googleMapsWaypointDistancesCntr) == distanceEveryResolutionMeters(distanceEveryResolutionMetersCntr))
           googleMapsWaypointDistancesHighRes(i) = googleMapsWaypointDistances(googleMapsWaypointDistancesCntr);
           googleMapsWaypointDistancesCntr = googleMapsWaypointDistancesCntr + 1;
           distanceEveryResolutionMetersCntr = distanceEveryResolutionMetersCntr + 1;
           howManyVectorValuesAreEqualCntr = howManyVectorValuesAreEqualCntr+1;
        end
    end

    googleMapsWaypointDistancesHighRes = googleMapsWaypointDistancesHighRes(1:(length(googleMapsWaypointDistancesHighRes)-howManyVectorValuesAreEqualCntr)); % gets rid of extra 0's at the end of vector
end

