function [velArrTriangle,tTo50KPH] = makeTriangleWithHeightEqualTo50KPH(deltaT,desAccel,distArray,k)
    disp('Make triangle with h=50!');
    v = 50/3.6; % v = v0+at
    tTo50KPH = v/desAccel; % v = v0+at -> t=v/a
    
    timeLengthTriangle = round(2*tTo50KPH,1); % rounds to nearest 0.1
    timeArray = (0:deltaT:timeLengthTriangle-deltaT)'; % intervals of deltaT sec
    velArrTriangle = zeros(length(timeArray),1);
    triangleTimeCntr = 0;
    for i=1:length(velArrTriangle) % iterate through vel array              
        if(triangleTimeCntr<=tTo50KPH) % time <= triangle midpoint time
            velArrTriangle(i) = interp1([0;round(tTo50KPH,1)],[0;v],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr > round(tTo50KPH,1)
            % need to extrapolate to make sure value is not NaN
        else % time > tTo50KPH
            velArrTriangle(i) = interp1([round(tTo50KPH,1)+deltaT;round(2*tTo50KPH,1)],[v;0],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr < round(tTo50KPH,1)
            % need to extrapolate to make sure value is not NaN
        end
        triangleTimeCntr = triangleTimeCntr + deltaT;
    end
    disp('distance h=50'); disp(distArray(k));
    disp('area under triangle h=50'); disp(sum(velArrTriangle)*deltaT);
    disp('what is k: '); disp(k);
end
