function velArrTriangle = makeTriangleWithHeightLessThan50KPH(deltaT,desAccel,distArray,k)
    disp('Make a triangle!');
    tTo50KPH = sqrt(distArray(k)/desAccel); % A_triang = v_end*tTo50KPH, v=atTo50KPH -> tTo50KPH = sqrt(A/a)
    disp('tTo50KPH: '); disp(tTo50KPH);
    v = desAccel*tTo50KPH; % v = v0+at
    timeLengthTriangle = round(2*tTo50KPH,1); % rounds to nearest 0.1
    timeArray = (0:deltaT:timeLengthTriangle-deltaT)'; % intervals of 0.1 sec
    velArrTriangle = zeros(length(timeArray),1);
    triangleTimeCntr = 0;
    for i=1:length(velArrTriangle) % iterate through vel array              
        if(triangleTimeCntr<=tTo50KPH) % time <= triangle midpoint time
            velArrTriangle(i) = interp1([0;round(tTo50KPH,1)],[0;v],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr > round(tTo50KPH,1)
            % need to extrapolate to make sure value is not NaN
        else % time > tTo50KPH
            velArrTriangle(i) = interp1([round(tTo50KPH,1)+deltaT;round(2*tTo50KPH,1)],[v;0],triangleTimeCntr,'linear','extrap'); % (t,v(t),t_interp), somehow triangleTimeCntr < round(tTo50KPH,1)
            % need to extrapolate to make sure value is not NaN
        end
        triangleTimeCntr = triangleTimeCntr + deltaT;
    end
    disp('distance triangle<50KPH'); disp(distArray(k));
    disp('area under triangle<50KPH'); disp(sum(velArrTriangle)*deltaT);
    disp('what is k: '); disp(k);
end

