clc; clear; close all; % working on this

load paramEstDynExcelFormattingOutput;% load data from paramEstimationDynamicExcelFormatting.m

%% find expression for OCV(z_k)

load paramEstimationOCVRunOutput; % loads OCVAtEvery0Point1PercentSoC, from parameterEstimationOCVRun.m
%% find tau_RC, gamma, M,M0,R1,R0 using EKF

deltaT = timeEKF(2)-timeEKF(1);

%clear vUpdated; clear secUpdated; clear currentUpdated;
ekfLength = length(timeEKF);
vEst = zeros(ekfLength,1);
testLength = ekfLength; % how long should EKF testing go??

%hwait = waitbar(0,'Computing...'); % shows progress bar for EKF calculations, uses waitbar.m function

for k=1:ekfLength
   % theta = [tauRC,gamma,M,M0,R1,R0]', dynamic parameters to estimate
   
    if(k==1) % initialization
        s = 0; sValueBefore = 0; sTemp = 0;
        thetaHatPlus = 0.1*ones(6,1); % ???, parameter covariance matrix
        x = zeros(3,ekfLength); % x = [iR1 h z]'
        x(3,1) = 1; % SoC starts at 100%
        thetaHatMinus = 0.1*ones(6,ekfLength);
        sumThetaTildePlus = 0.01*diag([1 1 1 1 1 1]); % 6x6 Theta covariance matrix
        sumRTilde = 0.001*diag([1 1 1 1 1 1]); % 6x6 param white noise covariance matrix
        sumETilde = 0.01; % 1x1 output equation white noise covariance matrix
        prevCHatTheta = zeros(1,6);
        recLimit = 1; % how many samples back should recursivedxdTheta() go, KEEP recLimit == 1 !!!
    end

    % EKF Step 1a
    thetaHatMinus(:,k) = thetaHatPlus;
    
    % EKF Step 1b
    sumThetaTildeMinus = sumThetaTildePlus + sumRTilde;
    %if(k>1940)
        %disp('sumThetaTildeMinus:');
        if(~issymmetric(sumThetaTildeMinus))
           sumThetaTildeMinus = makeMatrixSymmetric(sumThetaTildeMinus);
        end
        %checkSymmetryAndPositiveDefiniteness(sumThetaTildeMinus);
    %end
    
    % EKF Step 1c
    if(k==1)
        dHat = 0; % ???
    end
    if(k>1)
        TauRCHat = thetaHatMinus(1,k); gammaHat = thetaHatMinus(2,k);
        MHat = thetaHatMinus(3,k); M0Hat = thetaHatMinus(4,k);

        if(iEKF(k)==0)
            sTemp = s;
            s = sValueBefore;
            sValueBefore = sTemp;
        else
            sTemp = s;
            s = sign(iEKF(k)); % should be ik+ek, ???
            sValueBefore = sTemp;
        end

        tau1 = exp(-deltaT/(TauRCHat)); % need deltaT??
        A_RC = tau1;
        B_RC = 1-tau1;

        A_H = exp(-abs((iEKF(k)*gammaHat*deltaT)/Q_est)); % what about w??

        A = [A_RC 0 0;0 A_H 0; 0 0 1];
        B = [B_RC 0; 0 (A_H-1); -deltaT/Q_est 0];
        u = [iEKF(k) sign(iEKF(k))]'; % what about wk ???

        x(:,k) = A*x(:,k-1) + B*u; % x_k = Ax_k-1 + Bu_k-1
        h = x(2,k);
        R1Hat = thetaHatMinus(5,k);
        iR1 = x(1,k);
        R0Hat = thetaHatMinus(6,k);

        z = x(3,k); % in percent
        OCVAtZk = findOCVAtZk(OCVAtEvery0Point1PercentSoC,z);
        
        dHat = OCVAtZk+M0Hat*s+MHat*h-R1Hat*iR1-R0Hat*iEKF(k); % ek has zero mean, therefore not part of dHat
    end
    
    vEst(k) = dHat;
    
    % EKF Step 2a
    [CHatTheta,prevCHatTheta] = findCMatrix(k,thetaHatMinus,x,s,iEKF,deltaT,Q_est,prevCHatTheta,recLimit,OCVAtEvery0Point1PercentSoC);  
    DHatTheta = 1;

    sumDTilde = CHatTheta*sumThetaTildeMinus*CHatTheta' + sumETilde; % since DHatTheta = 1
    
    LTheta = sumThetaTildeMinus*CHatTheta'/(CHatTheta*sumThetaTildeMinus*CHatTheta' + sumETilde); % divide instead of inverse, denominator is 1x1
    if(isMatrixNaN(LTheta))
       LTheta = zeros(6,1); % -> thetaHatPlus = thetaHatMinus(:,k); sumThetaTildePlus = sumThetaTildeMinus;
    end
    
    
    % EKF Step 2b
    d = vEKF(k); % use measured voltage or Step 2a d_k
    thetaHatPlus = thetaHatMinus(:,k) + LTheta*(d-dHat);
    
    % see GP ESC Notes, page 2-31, thetaHatPlus=0 can lead to Inf in
    % recursive derivative calculations!
    thetaHatPlus(1) = minValue(10,max(1e-5,thetaHatPlus(1))); % tau_RC must be > 0, < 10
    thetaHatPlus(2) = minValue(500,max(1e-5,thetaHatPlus(2))); % gamma must be > 0, < 500
    thetaHatPlus(3) = minValue(1,max(1e-5,thetaHatPlus(3))); % M must be > 0, < 1
    thetaHatPlus(4) = minValue(1,max(1e-5,thetaHatPlus(4))); % M0 must be > 0, < 1
    thetaHatPlus(5) = minValue(1,max(1e-5,thetaHatPlus(5))); % R1 must be > 0, < 1
    thetaHatPlus(6) = minValue(1,max(1e-5,thetaHatPlus(6))); % R0 must be > 0, < 1

    
    % EKF Step 2c
    sumThetaTildePlus = sumThetaTildeMinus - LTheta*sumDTilde*LTheta';
    %sumThetaTildePlus = (eye(6)-LTheta*CHatTheta)*sumThetaTildeMinus*(eye(6)-LTheta*CHatTheta)' + (LTheta*sumETilde*LTheta'); % Joseph form covariance update, ensures symmetric & positive definite covariance matrix
    
    %if(k>1940)
        %disp('k=:');
        %disp(k);
        %disp('sumThetaTildePlus:');
        %disp(sumThetaTildePlus);
        if(~issymmetric(sumThetaTildePlus))
           sumThetaTildePlus = makeMatrixSymmetric(sumThetaTildePlus);
        end
        %disp('sumThetaTildePlus after:');
        %disp(sumThetaTildePlus);
        %checkSymmetryAndPositiveDefiniteness(sumThetaTildePlus);
    %end
    
%     if(mod(k,1000)==0) % slow procedure, only do every 1000 samples
%        waitbar(k/testLength,hwait); 
%     end
end

%close(hwait); % close the progress bar
disp('thetaHatPlus');
disp(thetaHatPlus);

%% Save important variables for SoC EKF
trueSoC = x(3,:); % 'true' SoC

filename = 'paramEstimationOutput.mat';
save(filename,'timeEKF','iEKF','vEKF','trueSoC','OCVAtEvery0Point1PercentSoC','thetaHatPlus','eta_25','Q_est');

%% plotting
% figure(1);
% plot(timeEKF(1:testLength),100*x(3,1:testLength));
% title('Time vs SoC'); xlabel('time [s]'); ylabel('SoC [%]');
% figure(2);
% plot(timeEKF(1:testLength),vEKF(1:testLength));
% title('Time vs voltage'); xlabel('time [s]'); ylabel('Voltage [V]');
% figure(3);
% plot(timeEKF(1:testLength),iEKF(1:testLength));
% title('Time vs current'); xlabel('time [s]'); ylabel('Current [A]');
% figure(4);
% plot(timeEKF(1:testLength),dischargeCapEKF(1:testLength));
% title('Time vs Discharge'); xlabel('time [s]'); ylabel('Discharge [Ah]');
% figure(5);
% plot(timeEKF(1:testLength),chargeCapEKF(1:testLength));
% title('Time vs Charge'); xlabel('time [s]'); ylabel('Charge [Ah]');

figure(6); plot(timeEKF,vEKF,timeEKF,vEst); legend('Real Voltage','Estimated Voltage');

error = vEKF-vEst;

figure(7); plot(error);