
clear; clc;

    %% import data from Excel
    filename = '/Users/bkvaale/Bjorn/Universities/NTNU/Semester9/FordypningsProsjekt/Revolve/Batteri Testing/IFE/Celletesting IFE 2017/Test8539_updated_25C_OCV_EssentialInfoForMatlab_Discharge.xlsx';
    sheet = 'Discharge';
    xlRange = 'M2:M9575'; % total time (s), discharge [Ah]
    timeDischarge = xlsread(filename,sheet,xlRange);
    xlRange = 'P2:P9575'; % total time (s), discharge [Ah]
    voltageDischarge = xlsread(filename,sheet,xlRange);
    xlRange = 'S2:S9575'; % total time (s), discharge [Ah]
    dischargeCapacitySum = xlsread(filename,sheet,xlRange);

    filename = '/Users/bkvaale/Bjorn/Universities/NTNU/Semester9/FordypningsProsjekt/Revolve/Batteri Testing/IFE/Celletesting IFE 2017/Test8539_updated_25C_OCV_EssentialInfoForMatlab_Charge.xlsx';
    sheet = 'Charge Data';
    xlRange = 'M2:M9987'; % total time (s)
    timeCharge = xlsread(filename,sheet,xlRange);
    xlRange = 'P2:P9987'; % charge [Ah]
    voltageCharge = xlsread(filename,sheet,xlRange);
    xlRange = 'S2:S9987'; % total time (s), charge [Ah]
    chargeCapacitySum = xlsread(filename,sheet,xlRange);

    %% take away unneeded data for DISCHARGE, some times can be repeated
    LDischarge = length(timeDischarge); % vector length

    indexTime = -1; % initialize to -1
    LDischargeUpdated = 0; % length counter
    timeDischargeUpdated = zeros(LDischarge,1); % initialize new time vector
    vDischargeUpdated = zeros(LDischarge,1); % initialize new voltage vector
    dischargeCapSumUpdated = zeros(LDischarge,1); % initialize new voltage vector
    for i=1:LDischarge
        if(indexTime~=timeDischarge(i,1)) % if time has not been used, then add it to new updated vectors
            indexTime = timeDischarge(i,1);
            timeDischargeUpdated(LDischargeUpdated+1,1) = timeDischarge(i,1);
            vDischargeUpdated(LDischargeUpdated+1,1) = voltageDischarge(i,1);
            dischargeCapSumUpdated(LDischargeUpdated+1,1) = dischargeCapacitySum(i,1);
            LDischargeUpdated=LDischargeUpdated+1; % increment counter
        end
    end;

    %clear time; clear voltage; clear indexTime; clear i; clear filename; % remove unneeded arrays and variables

    timeDischargeUpdated = timeDischargeUpdated(1:LDischargeUpdated); % remove unneeded zeros
    vDischargeUpdated = vDischargeUpdated(1:LDischargeUpdated); % remove unneeded zeros
    dischargeCapSumUpdated = dischargeCapSumUpdated(1:LDischargeUpdated); % remove unneeded zeros

    %% take away unneeded data for CHARGE, some times can be repeated

    LCharge = length(timeCharge); % vector length

    indexTime = -1; % initialize to -1
    LChargeUpdated = 0; % length counter
    timeChargeUpdated = zeros(LCharge,1); % initialize new time vector
    vChargeUpdated = zeros(LCharge,1); % initialize new voltage vector
    chargeCapSumUpdated = zeros(LCharge,1); % initialize new voltage vector
    for i=1:LCharge
        if(indexTime~=timeCharge(i,1)) % if time has not been used, then add it to new updated vectors
            indexTime = timeCharge(i,1);
            timeChargeUpdated(LChargeUpdated+1,1) = timeCharge(i,1);
            vChargeUpdated(LChargeUpdated+1,1) = voltageCharge(i,1);
            chargeCapSumUpdated(LChargeUpdated+1,1) = chargeCapacitySum(i,1);
            LChargeUpdated=LChargeUpdated+1; % increment counter
        end
    end;

    %clear time; clear voltage; clear indexTime; clear i; clear filename; % remove unneeded arrays and variables

    timeChargeUpdated = timeChargeUpdated(1:LChargeUpdated); % remove unneeded zeros
    vChargeUpdated = vChargeUpdated(1:LChargeUpdated); % remove unneeded zeros
    chargeCapSumUpdated = chargeCapSumUpdated(1:LChargeUpdated); % remove unneeded zeros

    %% update the time arrays for discharge and charge
        timeBiasDischarge = timeDischargeUpdated(1);
    for i=1:LDischargeUpdated
        timeDischargeUpdated(i) = timeDischargeUpdated(i) - timeBiasDischarge;
    end
        timeBiasCharge = timeChargeUpdated(1) - timeDischargeUpdated(LDischargeUpdated);
    for i=1:LChargeUpdated
        timeChargeUpdated(i) = timeChargeUpdated(i) - timeBiasCharge + 1;
    end

    %% put updated time, discharge sums & charge sums in one vector

    totalTime = [timeDischargeUpdated;timeChargeUpdated];
    %totalV = [];
    totalDischargeSum = [dischargeCapSumUpdated;dischargeCapSumUpdated(LDischargeUpdated)*ones(LChargeUpdated,1)];
    totalChargeSum = [zeros(LDischargeUpdated,1);chargeCapSumUpdated];

    %% calculate coulombic efficiency @ 25 degrees C

    dischargeSum = dischargeCapacitySum(LDischarge);
    L_charge = length(chargeCapacitySum);
    chargeSum = chargeCapacitySum(L_charge);

    eta_25 = dischargeSum/chargeSum;

    %% calculate Depth of Discharge (DoD) & cell capacity Q
    totalLength = length(totalTime);
    DoD = zeros(totalLength,1); % initialize DoD
    DoD = totalDischargeSum - eta_25*totalChargeSum;

    Q = totalDischargeSum(LDischargeUpdated); % [Ah]
    %figure(1);
    %plot(totalTime,DoD); xlabel('time [s]'); ylabel('DoD');

    %% calculate State of Charge (SoC)

    SoC = zeros(totalLength,1); % initialize SoC
    SoC = ones(totalLength,1) - DoD/Q; % SoC starts at 1, battery is dicharged to 0% -> battery charged to 100%
    %figure(2);
    %plot(totalTime,SoC); xlabel('time [s]'); ylabel('SoC');

    %% find internal resistance R0 value 100% SoC
    %figure(3);
    %plot(timeDischargeUpdated,vDischargeUpdated);

    % read off time period & voltages of instantaneous voltage drop, 679-689 seconds
    instVoltDrop = 4.1994-4.1986;
    current = 0.21614; % read off from excel sheet, is constant
    R0_100SoC = instVoltDrop/current;

    %% find internal resistance R0 value 0% SoC
    %figure(4);
    %plot(timeChargeUpdated,vChargeUpdated);

    % read off time period & voltages of instantaneous voltage drop, 679-689 seconds
    instVoltDrop = 3.0023-3.0014;
    %current = 3.275; % read off from excel sheet, is constant
    R0_0SoC = instVoltDrop/current; % charge current = discharge current

    %% find internal resistance R0 value 50% SoC

    instVoltDrop = 3.839 - 3.819; % read off from discharge & charge voltages vs SoC graph
    R0_50SoC = instVoltDrop/current; % charge current = discharge current, could be wrong??
    %R0_50SoC = (R0_0SoC+R0_100SoC)/2;
    %% find R0 values at every 1% SoC, old

%     R0AtEvery1PercentSoC = zeros(101,1); % first element corresponds to 0% SoC, last 100% SoC
%     R0AtEvery1PercentSoC(1) = R0_0SoC;
%     R0AtEvery1PercentSoC(51) = R0_50SoC;
%     R0AtEvery1PercentSoC(101) = R0_100SoC;
% 
%     for i=2:50
%         R0AtEvery1PercentSoC(i) = (R0_50SoC-R0_0SoC)/50*(i-1) + R0_0SoC;
%     end
% 
%     for i=52:100
%         R0AtEvery1PercentSoC(i) = (R0_100SoC-R0_50SoC)/50*(i-1) + 2*R0_50SoC - R0_100SoC;
%     end
%     
%     figure(2);
%     plot(0:100,R0AtEvery1PercentSoC); xlabel('SoC [%]'); ylabel('R0 [Ohm]');

    %% find R0 values at every 0.1% SoC, new
    
    R0AtEvery0Point1PercentSoC = zeros(1001,1); % first element corresponds to 0% SoC, last 100% SoC
    R0AtEvery0Point1PercentSoC(1) = R0_0SoC;
    R0AtEvery0Point1PercentSoC(501) = R0_50SoC;
    R0AtEvery0Point1PercentSoC(end) = R0_100SoC;

    for i=2:500
        R0AtEvery0Point1PercentSoC(i) = (R0_50SoC-R0_0SoC)/50*0.1*(i-1) + R0_0SoC; % not using 1% SoC increments anymore
    end

    for i=502:length(R0AtEvery0Point1PercentSoC)-1
        R0AtEvery0Point1PercentSoC(i) = (R0_100SoC-R0_50SoC)/50*0.1*(i-1) + 2*R0_50SoC - R0_100SoC;
    end   
    
    figure(1);
    plot(0:0.1:100,R0AtEvery0Point1PercentSoC); xlabel('SoC [%]'); ylabel('R0 [Ohm]');

     %% update discharge & charge voltages, only one per SoC, old
% 
%     indexSoC = -1; % initialize
%     indexCntr = 101;
%     vDischUpdEvery1PercentSoC = zeros(length(R0AtEvery1PercentSoC),1); % initialize
%     for i=1:LDischargeUpdated
%         roundedSoC = round(100*SoC(i));
%         if(indexSoC~=roundedSoC) % if SoC has not been used, then add it to new updated vectors
%             indexSoC=roundedSoC; % update indexSoC
%             vDischUpdEvery1PercentSoC(indexCntr) = vDischargeUpdated(i);
%             indexCntr=indexCntr-1;
%         end
%     end
% 
%     indexSoC = -1; % initialize
%     indexCntr = 1;
%     vChrgeUpdEvery1PercentSoC = zeros(length(R0AtEvery1PercentSoC),1); % initialize
%     for i=LDischargeUpdated+1:totalLength
%         roundedSoC = round(100*SoC(i));
%         if(indexSoC~=roundedSoC) % if SoC has not been used, then add it to new updated vectors
%             indexSoC=roundedSoC; % update indexSoC
%             vChrgeUpdEvery1PercentSoC(indexCntr) = vChargeUpdated(i-LDischargeUpdated);
%             indexCntr=indexCntr+1;
%         end
%     end

    %% update discharge & charge voltages, only one per SoC, new

    indexSoC = -1; % initialize
    indexCntr = length(R0AtEvery0Point1PercentSoC);
    vDischUpdEvery0Point1PercentSoC = zeros(length(R0AtEvery0Point1PercentSoC),1); % initialize
    for i=1:LDischargeUpdated
        roundedSoC = round(1000*SoC(i));
        if(indexSoC~=roundedSoC) % if SoC has not been used, then add it to new updated vectors
            indexSoC=roundedSoC; % update indexSoC
            vDischUpdEvery0Point1PercentSoC(indexCntr) = vDischargeUpdated(i);
            indexCntr=indexCntr-1; % SoC starts at 100%, goes down to 0%, array should be filled up so last element is 100% SoC
        end
    end

    
    indexSoC = -1; % initialize
    indexCntr = 1;
    vChrgeUpdEvery0Point1PercentSoC = zeros(length(R0AtEvery0Point1PercentSoC),1); % initialize
    for i=LDischargeUpdated+1:totalLength
        roundedSoC = round(1000*SoC(i));
        if(indexSoC~=roundedSoC) % if SoC has not been used, then add it to new updated vectors
            indexSoC=roundedSoC; % update indexSoC
            vChrgeUpdEvery0Point1PercentSoC(indexCntr) = vChargeUpdated(i-LDischargeUpdated);
            indexCntr=indexCntr+1;
        end
    end
    
    %% testing
%     figure(3);
%     plot(0:0.1:100,vChrgeUpdEvery0Point1PercentSoC,0:0.1:100,vDischUpdEvery0Point1PercentSoC);
%     xlabel('SoC [%]'); ylabel('Voltage [V]'); legend('Charge Voltage','Discharge Voltage');

%% find OCV as a function of SoC

OCVAtEvery0Point1PercentSoC = zeros(length(R0AtEvery0Point1PercentSoC),1); % first element corresponds to OCV @ 0% SoC, last to OCV @ 100% SoC

OCVAtEvery0Point1PercentSoC(1:501) = vChrgeUpdEvery0Point1PercentSoC(1:501)-current*R0AtEvery0Point1PercentSoC(1:501); % for SoC from 0-50%
OCVAtEvery0Point1PercentSoC(502:end) = vDischUpdEvery0Point1PercentSoC(502:end)+current*R0AtEvery0Point1PercentSoC(502:end); % for SoC from 51-100%

figure(3);
plot(0:0.1:100,OCVAtEvery0Point1PercentSoC); xlabel('SoC [%]'); ylabel('Voltage [V]');
    
% save file at two different locations
filename = 'paramEstimationOCVRunOutput.mat';
save(filename,'OCVAtEvery0Point1PercentSoC');
filename = '/Users/bkvaale/Bjorn/Universities/NTNU/Semester10/RangeEstimation/paramEstimationOCVRunOutput.mat';
save(filename,'OCVAtEvery0Point1PercentSoC');

%% export for runtime calculations

filename = 'paramEstimationOCVRunBatteryRunTimeCalc.mat';
save(filename,'current','OCVAtEvery0Point1PercentSoC','totalTime','vChargeUpdated','vDischargeUpdated','Q');

%% testing
% load 'paramEstimationOCVRunOutput_old'
% 
% figure(4);
% plot(0:0.1:100,OCVAtEvery0Point1PercentSoC,0:100,OCVAtEvery1PercentSoC); xlabel('SoC [%]'); ylabel('Voltage [V]');
% legend('0.1% SoC Increments','1% SoC Increments');
    
    %% plot discharge & charge voltages as functions of SoC instead of time

    SoCEvery1Percent = 0:100;
    SoCEvery1Percent = SoCEvery1Percent';

%     figure(5);
%     plot(100*SoC(1:LDischargeUpdated),vDischargeUpdated,100*SoC(LDischargeUpdated+1:totalLength),vChargeUpdated,SoCEvery1Percent,OCVAtEvery1PercentSoC);
%     xlabel('SoC [%]'); ylabel('Voltage [V]'); legend('Discharge Voltage','Charge Voltage','OCV');
    